/**
 * \file    15WG1_EPD.h
 * \brief   E-Paper Display Modul 1.54" header file
 * \author  eQ-3 Entwicklung GmbH
**/
/*-----------------------------------------------------------------------------
 * Copyright 2016 eQ-3 Entwicklung GmbH
 * All Rights Reserved.
 *
 * The information contained in this file is confidential property of "eQ-3
 * Entwicklung GmbH". The use copying, transfer or disclosure is prohibited
 * except by written agreement with "eQ-3 Entwicklung GmbH".
 *---------------------------------------------------------------------------*/
/*
 * $URL$
 * $Author$
 * $Date$
 * $Revision$
 */

/** \addtogroup EPD_15WG1
 *  \{
**/
/*---------------------------------------------------------------------------*/

#ifndef  DISPLAY_15WG1_EPD_H
#define  DISPLAY_15WG1_EPD_H

/**
 * Defines section -----------------------------------------------------------
**/
#define DEEPSLEEP															0x10
#define DATAENTRY															0x11
#define SWRESET																0x12
#define DISPLAY_CTRL													0x22
#define WRITE_RAM															0x24
#define RAM_X_COUNT														0x4e
#define RAM_Y_COUNT														0x4f

#define REFRESH                               280
#define REFMODE_1                             1
#define REFMODE_2                             2
#define REFMODE_3                             3
#define REFMODE_4                             4

#define BLACK                                 0x00
#define WHITE                                 0xFF

#define DASHED                                0xCC
#define DASHED_INV                            0x33
#define DASHEDTHICK                           0x81
#define DASHEDTHIN                            0x7E

#define CHESSBOARD1                           0xF0
#define CHESSBOARD2                           0x0F

#define WHITEDOTS                             0x11
#define BLACKDOTS                             0xEE

#define WHITE_BACK                            0
#define BLACK_BACK                            1

#define LSB                                   0
#define MSB																		1

#define COURIER																0
#define CONSOLAS                              1

#define WHITE_FONT														0	
#define BLACK_FONT														1

#define FONT_HALF_BYTE_SIZE                   10

#define FONT_BIG_HALF_BYTE_SIZE		            15

#define EPD_15WG1_BUSY_PORT										gpioPortB
#define EPD_15WG1_BUSY_PIN                    13
#define EPD_15WG1_BUSY 												GPIO_PinInGet(EPD_15WG1_BUSY_PORT, EPD_15WG1_BUSY_PIN)

#define EPD_15WG1_RESET_PORT 									gpioPortB
#define EPD_15WG1_RESET_PIN    								14
#define EPD_15WG1_RESET_HIGH           				SET(EPD_15WG1_RESET_PORT, EPD_15WG1_RESET_PIN)
#define EPD_15WG1_RESET_LOW          					CLEAR(EPD_15WG1_RESET_PORT, EPD_15WG1_RESET_PIN)

#define EPD_15WG1_CS_PORT      								gpioPortB
#define EPD_15WG1_CS_PIN   										8 
#define EPD_15WG1_DC_PORT      								gpioPortD
#define EPD_15WG1_DC_PIN   										4
#define EPD_15WG1_CS_HIGH           					SET(EPD_15WG1_CS_PORT, EPD_15WG1_CS_PIN)
#define EPD_15WG1_CS_LOW          						CLEAR(EPD_15WG1_CS_PORT, EPD_15WG1_CS_PIN)
#define EPD_15WG1_DC_HIGH           					SET(EPD_15WG1_DC_PORT , EPD_15WG1_DC_PIN)
#define EPD_15WG1_DC_LOW          						CLEAR(EPD_15WG1_DC_PORT , EPD_15WG1_DC_PIN)


/**
 * Function prototypes section ------------------------------------------------
**/
void EPD_15WG1_init(void);
void EPD_15WG1_DispInit(void);
void EPD_15WG1_Update(void);
void EPD_15WG1_Deep_sleep(void);
void EPD_15WG1_SW_reset(void);
void EPD_15WG1_WriteLUT(uint8_t *);
void EPD_15WG1_Write_CMD(uint8_t);
void EPD_15WG1_Write_DATA(uint8_t);
void EPD_15WG1_Write_CMD_para(uint8_t, uint8_t);
void EPD_15WG1_Write_CMD_para_2(uint8_t, uint8_t, uint8_t);
void EPD_15WG1_Write_point(uint8_t *, uint8_t );
void EPD_15WG1_Refresh(uint16_t);
void EPD_15WG1_WriteDispRamMono(uint16_t);
void EPD_15WG1_WriteDispRamStripes(uint16_t, uint16_t);
void EPD_15WG1_WriteDispRamVertikLine(uint16_t, uint16_t);
void EPD_15WG1_WriteDispRamMuster(uint16_t, uint16_t);
void EPD_15WG1_WriteDispRamDots(uint16_t, uint16_t, uint16_t);
void EPD_15WG1_WriteDispRamChessboard(uint16_t, uint16_t, uint16_t);
void EPD_15WG1_UploadDisplay(const uint8_t *, uint16_t);
void EPD_15WG1_Show_String(uint8_t *, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t);

#endif /* DISPLAY_15WG1_EPD_H */


/** \}
 * End of file
**/
