/**
 * \file    15WG1_SPI.h
 * \brief   Display SPI routines header file
 * \author  eQ-3 Entwicklung GmbH
**/
/*-----------------------------------------------------------------------------
 * Copyright 2016 eQ-3 Entwicklung GmbH
 * All Rights Reserved.
 *
 * The information contained in this file is confidential property of "eQ-3
 * Entwicklung GmbH". The use copying, transfer or disclosure is prohibited
 * except by written agreement with "eQ-3 Entwicklung GmbH".
 *---------------------------------------------------------------------------*/
/*
 * $URL$
 * $Author$
 * $Date$
 * $Revision$
 */

/** @addtogroup EPD_15WG1
 *  @{
**/
/*---------------------------------------------------------------------------*/

#ifndef  SPI_15WG1_H
#define  SPI_15WG1_H

/**
 * Includes section -----------------------------------------------------------
**/
#include "defines.h"
#include "em_gpio.h"
#include "em_device.h"
#include "../../typedefs/typedefs_efm32.h" 


/**
 * Defines section -----------------------------------------------------------
**/
#define SPI_15WG1_USART 											USART1
#define SPI_15WG1_CLOCK 											cmuClock_USART1

#define USART0_NUM              							0
#define USART1_NUM              							1
#define USART2_NUM             		  					2

#define USART_ROUTE_LOCATION_0  							0
#define USART_ROUTE_LOCATION_1      					1
#define USART_ROUTE_LOCATION_2      					2

#define SPI_15WG1_PORT_TX  										gpioPortC
#define SPI_15WG1_PIN_TX   										0
#define SPI_15WG1_PORT_CLK 										gpioPortB
#define SPI_15WG1_PIN_CLK  										7

#define SPI_15WG1_BAUDRATE            				1000000

#define SPI_15WG1_SEND(x)                     USART_SpiTransfer(SPI_15WG1_USART, x)


/**
 * Function prototypes section ------------------------------------------------
**/
void SPI_15WG1_init(void);
void SPI_15WG1_setup(uint8_t, uint8_t);
void SPI_15WG1_Write(uint8_t);  
void SPI_15WG1_xSB (uint16_t);

#endif /* SPI_15WG1_H */

/** \}
 * End of file
**/
