/**
 * \file    gpio.c
 * \brief   The file contains the functions for gpio handling
 * \author  eQ-3 Entwicklung GmbH
**/
/*-----------------------------------------------------------------------------
 * Copyright 2016 eQ-3 Entwicklung GmbH
 * All Rights Reserved.
 *
 * The information contained in this file is confidential property of "eQ-3
 * Entwicklung GmbH". The use copying, transfer or disclosure is prohibited
 * except by written agreement with "eQ-3 Entwicklung GmbH".
 *---------------------------------------------------------------------------*/
/*
 * $URL$
 * $Author$
 * $Date$
 * $Revision$
 */

/** @addtogroup GPIO
 *  @{
**/
/*---------------------------------------------------------------------------*/

/**
 * Includes section -----------------------------------------------------------
**/
#include "em_cmu.h"
#include "em_gpio.h"
#include "defines.h"
#include "gpio.h"
#include "../display/15WG1/15WG1_EPD.h"


/**
 *  Function section ----------------------------------------------------------
**/

/**
 * \brief Initialization of the GPIO (EPD)
 *
 * \param none
 * \retval none
**/
void GPIO_port_init()
{
  CMU_ClockEnable(cmuClock_GPIO, true); 
	GPIO_EPD_port_init();
}


/**
 * \brief  Initialisation of the EPD GPIOnitialization of the GPIO (EPD)
 *
 * \param none
 * \retval none
**/
void GPIO_EPD_port_init( void )
{
	GPIO_PinModeSet( EPD_15WG1_CS_PORT, EPD_15WG1_CS_PIN, gpioModePushPull, 1);
	GPIO_PinModeSet( EPD_15WG1_DC_PORT, EPD_15WG1_DC_PIN, gpioModePushPull, 1);
	GPIO_PinModeSet( EPD_15WG1_BUSY_PORT, EPD_15WG1_BUSY_PIN, gpioModeInput, 0);
	GPIO_PinModeSet( EPD_15WG1_RESET_PORT, EPD_15WG1_RESET_PIN, gpioModePushPull, 1);
}


/** \}
 * End of file
**/
