/**
 * \file    gpio.h
 * \brief   The file contains the function prototypes and defines for gpio handling
 * \author  eQ-3 Entwicklung GmbH
**/
/*-----------------------------------------------------------------------------
 * Copyright 2016 eQ-3 Entwicklung GmbH
 * All Rights Reserved.
 *
 * The information contained in this file is confidential property of "eQ-3
 * Entwicklung GmbH". The use copying, transfer or disclosure is prohibited
 * except by written agreement with "eQ-3 Entwicklung GmbH".
 *---------------------------------------------------------------------------*/
/*
 * $URL$
 * $Author$
 * $Date$
 * $Revision$
 */

/** @addtogroup GPIO
 *  @{
**/
/*---------------------------------------------------------------------------*/

#ifndef __GPIO_H__
#define __GPIO_H__

/**
 * Includes section -----------------------------------------------------------
**/
#include "em_gpio.h"


/**
 * Defines section -----------------------------------------------------------
**/
#define GPIO_set_lo( x )								GPIO_PinOutClear( x##_PORT, x##_PIN )
#define GPIO_set_hi( x )								GPIO_PinOutSet( x##_PORT, x##_PIN )
#define GPIO_toggle( x )								GPIO_PinOutToggle( x##_PORT, x##_PIN )
#define GPIO_get( x )										GPIO_PinInGet( x##_PORT, x##_PIN )


/**
 * Function prototypes section ------------------------------------------------
**/
void GPIO_port_init( void );
void GPIO_EPD_port_init( void );

#endif /* __GPIO_H__ */

/** \}
 * End of file
**/
