/**
 * \file    init.c
 * \brief   The file contains the functions for initialization
 * \author  eQ-3 Entwicklung GmbH
**/
/*-----------------------------------------------------------------------------
 * Copyright 2016 eQ-3 Entwicklung GmbH
 * All Rights Reserved.
 *
 * The information contained in this file is confidential property of "eQ-3
 * Entwicklung GmbH". The use copying, transfer or disclosure is prohibited
 * except by written agreement with "eQ-3 Entwicklung GmbH".
 *---------------------------------------------------------------------------*/
/*
 * $URL$
 * $Author$
 * $Date$
 * $Revision$
 */

/** @addtogroup INIT
 *  @{
**/
/*---------------------------------------------------------------------------*/

/**
 * Includes section -----------------------------------------------------------
**/
#include "em_device.h"
#include "em_chip.h"
#include "em_emu.h"
#include "em_cmu.h"
#include "em_int.h"
#include "defines.h"
#include "init.h"
#include "../gpio/gpio.h"


/**
 *  Function section ----------------------------------------------------------
**/
 
/*!
 ******************************************************************************
 * @brief main initialisation of the controller
 *
 * @param NONE
 * @return NONE
**/
void INIT_uc_init()
{  
	CHIP_Init();
	INT_Enable();
	
  INIT_clock_init();   
	
  GPIO_port_init();
}


/*!
 ******************************************************************************
 * @brief initialisation of the clock
 *
 * @param NONE
 * @return NONE
**/
void INIT_clock_init( void )
{ 
  CMU_ClockSelectSet(cmuClock_HF, cmuSelect_HFRCO);                       // Using HFRCO at 14MHz as high frequency clock, HFCLK
}


/** \}
 * End of file
**/
