/**
 * \file    typedefs.h
 * \brief   This file contains the type definitions for the 
 *          KEIL IDE for EFM32 mikrocontroler
 * \author  eQ-3 Entwicklung GmbH
**/
/*-----------------------------------------------------------------------------
 * Copyright 2016 eQ-3 Entwicklung GmbH
 * All Rights Reserved.
 *
 * The information contained in this file is confidential property of "eQ-3
 * Entwicklung GmbH". The use copying, transfer or disclosure is prohibited
 * except by written agreement with "eQ-3 Entwicklung GmbH".
 *---------------------------------------------------------------------------*/
/*
 * $URL$
 * $Author$
 * $Date$
 * $Revision$
 */
 
/** \addtogroup eQ3-Library eQ3-Library
 *  \{
 *  Collection of routines programmed by eQ-3 Entwicklung GmbH
**/

/** \defgroup Utilities Utilities
 *  \{
 *  Collection of frequently used programmroutines
**/

/** \defgroup Typedefs_EFM32 Typedefs_EFM32
 *  \{ 
 *  Type definitions for EFM32
**/ 
/*---------------------------------------------------------------------------*/ 


#ifndef __TYPEDEFS_EFM32_H__
#define __TYPEDEFS_EFM32_H__

#include <stdint.h>

/** 
 * Integer types: signed
**/
typedef signed char sint8_t;           /*  8 bits, -128 to 127     */
typedef signed short sint16_t;         /* 16 bits, -32768 to 32767 */
typedef signed long sint32_t;          /* 32 bits, -2^31 to 2^31-1 */
typedef signed long long sint64_t;     /* 64 bits, -2^63 to 2^63-1 */

/**
 * Floating point types
**/
typedef float float32_t;              /* 1 bit sign,  8 bits exponent, 23 bits mantissa */
typedef long double float64_t;        /* 1 bit sign, 11 bits exponent, 52 bits mantissa */

/**
 * Bool type
**/
typedef enum
{
  __FALSE = 0,
  __TRUE  = !__FALSE
} bool_t;

#endif /* __TYPEDEFS_EFM32_H__ */

/** \} */
/** \} */
/** \}
 * End of file
**/
